
       SUBROUTINE BOOT_ICE_NSBA(nc,nr,v37,v19,h37,
     >                  v22,iceout,landval,missval,
     >                  land,month,day,satellite)

        integer*2 land(nc,nr)
        integer*4 nc,nr
        real*4    v37(nc,nr),h37(nc,nr),v19(nc,nr),
     >            v22(nc,nr),iceout(nc,nr),
     >            landval,missval
        character*2 month,day
        character*9 satellite
        
        integer*2 gdata(nc,nr)
        integer*4 set,pole,seas,i,j
        real*4    wtp(2),itp(2),wtp2(2),itp2(2),
     >            v1937(2),vh37(2),
     >            wintrc,wslope,wxlimt,
     >            watchk1,watchk2,
     >            ln(2),lnchk,adoff,vh37chk,
     >            radslp1,radoff1,radlen1,radslp2,radoff2,radlen2,
     >            radchk,xint,yint,icpix,iclen,
     >            add1,add2,mintb,maxtb,maxic,minic
        integer*2 imonth,iday

        mintb=10.0
        maxtb=320.0
        maxic=1.0
        minic=10.0
        add1=0.0
        add2=-2.0
        pole=1
        seas=1

        read(month,'(i2)') imonth
        read(day,'(i2)') iday
        if (imonth .ge. 6 .and. imonth .le. 9) seas=2
        if (imonth .eq. 10 .and. iday .le. 15) seas=2

        if (satellite .eq. 'F17_final') then
           CALL xfer_tbs_sba_f17_final(nc,nr,v37,h37,v19,v22)
        else
           CALL xfer_tbs_sba(nc,nr,v37,h37,v19,v22)
        endif

        do i=1,nr
        do j=1,nc
        if (v37(j,i).lt.mintb .or. v37(j,i).gt.maxtb .or.
     >      h37(j,i).lt.mintb .or. h37(j,i).gt.maxtb .or.
     >      v19(j,i).lt.mintb .or. v19(j,i).gt.maxtb .or.
     >      v22(j,i).lt.mintb .or. v22(j,i).gt.maxtb) then
            gdata(j,i)=1
        else
            gdata(j,i)=0
        endif
        enddo
        enddo

        set=1
        CALL ret_para_nsba(set,wtp,itp,vh37,
     >                     wintrc,wslope,wxlimt,
     >                     ln,lnchk,seas)

        CALL ret_linfit1(nc,nr,land,gdata,v37,h37,
     >                   v19,v22,ln,lnchk,
     >                   wslope,wintrc,wxlimt,add1,vh37)

        CALL ret_adj_adoff(wtp,vh37,adoff)

        set=2
        CALL ret_para_nsba(set,wtp2,itp2,v1937,
     >                     wintrc,wslope,wxlimt,
     >                     ln,lnchk,seas)

        CALL ret_linfit2(nc,nr,land,gdata,v37,v19,
     >                   v19,v22,ln,lnchk,
     >                   wslope,wintrc,wxlimt,add2,v1937,
     >                   h37,vh37,adoff)

        radslp1=(itp(2)-wtp(2))/(itp(1)-wtp(1))
        radoff1= wtp(2) - (wtp(1)*radslp1)
        xint=(radoff1 - vh37(1))/(vh37(2) - radslp1)
        yint=(vh37(2) * xint) + vh37(1)
        radlen1=sqrt( (xint-wtp(1))**2 + (yint-wtp(2))**2)

        radslp2=(itp2(2)-wtp2(2))/(itp2(1)-wtp2(1))
        radoff2= wtp2(2) - (wtp2(1)*radslp2)
        xint=(radoff2 - v1937(1))/(v1937(2) - radslp2)
        yint=(v1937(2) * xint) + v1937(1)
        radlen2=sqrt( (xint-wtp2(1))**2 + (yint-wtp2(2))**2)

        do i=1,nr
        do j=1,nc
           if (land(j,i) .ne. 0) then
                iceout(j,i)=landval
           elseif (gdata(j,i) .ne. 0) then
                iceout(j,i)=missval
           else
                watchk1=(wslope * v22(j,i)) + wintrc
                watchk2=v22(j,i) - v19(j,i)
                if (watchk1 .gt. v19(j,i) .or. 
     >              watchk2 .gt. wxlimt) then
                    iceout(j,i)=0.0
                else
                    vh37chk=(vh37(1)-adoff)+(vh37(2)*v37(j,i))
                    if (h37(j,i) .gt. vh37chk) then
                        radchk=(radslp1*v37(j,i))+radoff1
                        if (h37(j,i) .lt. radchk) then
                            iclen=sqrt((v37(j,i)-wtp(1))**2 + 
     >                                 (h37(j,i)-wtp(2))**2)
                            if (iclen .gt. radlen1) then
                                icpix=1.0
                            else
                                icpix=iclen/radlen1
                            endif
                        else
                            CALL ret_ic(icpix,v37(j,i),h37(j,i),
     >                                  wtp(1),wtp(2),vh37,
     >                                  missval,maxic)
                        endif
                    else
                        radchk=(radslp2*v37(j,i))+radoff2
                        if (v19(j,i) .lt. radchk) then
                            iclen=sqrt((v37(j,i)-wtp2(1))**2 + 
     >                                 (v19(j,i)-wtp2(2))**2)
                            if (iclen .gt. radlen2) then
                                icpix=1.0
                            else
                                icpix=iclen/radlen2
                            endif
                        else
                            CALL ret_ic(icpix,v37(j,i),v19(j,i),
     >                                  wtp2(1),wtp2(2),v1937,
     >                                  missval,maxic)
                        endif
                    endif
                    if (icpix .ne. missval) then
                        iceout(j,i)=icpix*100.0
                    else
                        iceout(j,i)=missval
                    endif
                endif
            endif
        enddo
        enddo

        CALL sst_clean(nc,nr,iceout,missval,landval,month,pole)
        CALL spatial_interp(nc,nr,iceout,missval,landval)
        CALL coastal_fix(nc,nr,iceout,missval,landval,minic)

        do i=1,nr
        do j=1,nc
            if (iceout(j,i) .lt. minic) iceout(j,i) = 0.0
        enddo
        enddo

        RETURN
        END
