
        SUBROUTINE SST_CLEAN(nc,nr,arr,missval,landval,month,pole)

        integer*4   nc,nr,pole
        real*4      arr(nc,nr),missval,landval
        character*2 month

        integer*2 x,y,fact,status
        integer*2 sst_mask_s(632,664),sst_mask_n(608,896)
        integer*4 ncc,nrr,logfile_unit
        character*12 sst_file
        character*80 ancillary_dir
        character*240 filearg

        if (nc .lt. 500) then
          fact = 2.0
        else
          fact = 1.0
        endif

        ncc=nc*fact
        nrr=nr*fact
        status=0
        logfile_unit=10

        call getenv('BOOTSTRAP_V2_ANCILLARY', ancillary_dir)

        if (pole .eq. 1) then
          sst_file = 'sst_n_'//month//'.hdf'
          filearg=ancillary_dir(1:index(ancillary_dir, ' ') - 1)
     &         //'/'//sst_file
          call read_hdf_land(filearg, ncc, nrr, 
     &                  '',sst_mask_n, logfile_unit, status)
          if (fact .eq. 1) then
            do y=1,nr
            do x=1,nc
              if (arr(x,y) .ne. landval .and. arr(x,y) .ne. missval
     &            .and. sst_mask_n(x,y) .gt. 2780 ) arr(x,y) = 0.0
            enddo 
            enddo
          else
            do y=1,nr
            do x=1,nc
            if (arr(x,y) .ne. landval .and. arr(x,y) .ne. missval) then 
              if (sst_mask_n((x*2)-1,(y*2)-1) .gt. 2780 .or.
     &            sst_mask_n((x*2)  ,(y*2)-1) .gt. 2780 .or.
     &            sst_mask_n((x*2)-1,(y*2)  ) .gt. 2780 .or.
     &            sst_mask_n((x*2)  ,(y*2)  ) .gt. 2780) arr(x,y) = 0.0
            endif
            enddo 
            enddo
          endif
        else
          sst_file = 'sst_s_'//month//'.hdf'
          filearg=ancillary_dir(1:index(ancillary_dir, ' ') - 1)
     &      //'/'//sst_file
          call read_hdf_land(filearg, ncc, nrr, 
     &                  '',sst_mask_s, logfile_unit, status)
          if (fact .eq. 1) then
            do y=1,nr
            do x=1,nc
              if (arr(x,y) .ne. landval .and. arr(x,y) .ne. missval
     &            .and. sst_mask_s(x,y) .gt. 2750 ) arr(x,y) = 0.0
            enddo 
            enddo
          else
            do y=1,nr
            do x=1,nc
            if (arr(x,y) .ne. landval .and. arr(x,y) .ne. missval) then 
              if (sst_mask_s((x*2)-1,(y*2)-1) .gt. 2750 .or.
     &            sst_mask_s((x*2)  ,(y*2)-1) .gt. 2750 .or.
     &            sst_mask_s((x*2)-1,(y*2)  ) .gt. 2750 .or.
     &            sst_mask_s((x*2)  ,(y*2)  ) .gt. 2750) arr(x,y) = 0.0
            endif
            enddo 
            enddo
          endif
        endif

        RETURN
        END


        SUBROUTINE SPATIAL_INTERP(nc,nr,arr,missval,landval)

        integer*4 nc,nr 
        real*4    arr(nc,nr),missval,landval

        integer*2 i,x,x2,y,y2
        real*4    tmparr(nc,nr),sum,pop 

        do y=1,nr
          do x=1,nc
            tmparr(x,y)=arr(x,y)
            if (arr(x,y) .eq. missval) then
              sum=0.0
              pop=0.0
              do y2=y-1,y+1
                do x2=x-1,x+1
                  if ( (x2 .ge. 1) .and. (x2 .le. nc) .and. 
     &                 (y2 .ge. 1) .and. (y2 .le. nr) ) then
                    if ( (arr(x2,y2) .ne. missval ) .and.
     &                   (arr(x2,y2) .ne. landval ) ) then
                      sum = sum + arr(x2,y2)    
                      pop = pop + 1.0
                    endif
                  endif
                enddo
              enddo
              if (pop .gt. 1.0) then
                tmparr(x,y)=sum/pop
              endif 
            endif
          enddo
        enddo

        do y=1,nr
          do x=1,nc
            arr(x,y)=tmparr(x,y)  
          enddo
        enddo

        RETURN
        END


        SUBROUTINE COASTAL_FIX(nc,nr,arr,missval,landval,minic)

        integer*4 nc,nr 
        real*4    arr(nc,nr),missval,landval,minic

        integer*2 i,j,k,p,set,temp(nc,nr)       
        real*4    arr2(nc,nr)

        set=2

        do i=1,nr
        do j=1,nc
          arr2(j,i)=arr(j,i)
          if (arr(j,i) .eq. landval .or. (arr(j,i) .ge. 0.0 .and.
     >      arr(j,i) .lt. minic)) then
            temp(j,i)=-1
          else
            temp(j,i)=1
          endif
        enddo
        enddo

        do i=1,nr
        do j=1,nc
        if (arr(j,i) .gt. 0.0 .and. arr(j,i) .le. 100.0) then
            if (i .gt. 1) then
                if (arr(j,i-1) .eq. landval) then
                    do k=1,set
                        if (i+k .le. nr) then           
                            if (arr(j,i+k) .ge. 0 .and. arr(j,i+k) .lt.
     >                        minic) then
                                do p=0,k-1
                                    if (i+p .le. nr) then 
                                        if (arr(j,i+p) .gt. 0 .and. 
     >                                      arr(j,i+p) .ne. missval
     >                                      .and. arr(j,i+p) .ne.
     >                                      landval) temp(j,i+p) = 0
                                    endif
                                enddo
                            endif
                        endif
                    enddo
                endif
            endif
            if (i .lt. nr) then
                if (arr(j,i+1) .eq. landval) then
                    do k=1,set
                        if (i-k .gt. 0) then    
                            if (arr(j,i-k) .ge. 0 .and. arr(j,i-k) .lt.
     >                        minic) then
                                do p=0,k-1
                                    if (i-p .gt. 0) then
                                        if (arr(j,i-p) .gt. 0 .and. 
     >                                      arr(j,i-p) .ne. missval
     >                                      .and. arr(j,i-p) .ne.
     >                                      landval) temp(j,i-p) = 0
                                    endif
                                enddo
                            endif
                        endif
                    enddo
                endif
            endif
            if (j .gt. 1) then  
                if (arr(j-1,i) .eq. landval) then
                     do k=1,set
                         if (j+k .le. nc) then          
                             if (arr(j+k,i) .ge. 0 .and.
     >                         arr(j+k,i) .lt. minic) then 
                                 do p=0,k-1
                                     if (j+p .le. nc) then
                                         if (arr(j+p,i) .gt. 0 .and. 
     >                                       arr(j+p,i) .ne. missval
     >                                       .and.
     >                                       arr(j+p,i) .ne. landval)
     >                                       temp(j+p,i) = 0
                                     endif
                                 enddo
                             endif
                         endif
                     enddo
                 endif
            endif
            if (j .lt. nc-1) then
                if (arr(j+1,i) .eq. landval) then
                    do k=1,set
                        if (j-k .gt. 0) then    
                            if (arr(j-k,i) .ge. 0 .and.
     >                        arr(j-k,i) .lt. minic)  then
                                do p=0,k-1
                                    if (j-p .gt. 0) then
                                        if (arr(j-p,i) .gt. 0 .and. 
     >                                      arr(j-p,i) .ne. missval
     >                                      .and.
     >                                      arr(j-p,i) .ne. landval)
     >                                       temp(j-p,i) = 0
                                    endif
                                enddo
                            endif
                        endif
                    enddo
                endif
            endif
        endif
        enddo
        enddo

        do i=1,nr
        do j=1,nc
        if (temp(j,i) .eq. 0) then
            if (i .gt. 1) then  
                if (arr(j,i-1) .eq. landval) then
                    if (j .eq. 1) then
                        if (i .lt. nr) then
                            if (temp(j+1,i+1) .le. 0) then
                                if (temp(j,i+1) .eq. 0) arr2(j,i+1) = 0
                                if (temp(j+1,i) .le. 0) arr2(j,i) = 0
                            endif
                        endif
                    else if (j .eq. nc) then    
                        if (i .lt. nr) then
                            if (temp(j-1,i+1) .le. 0) then
                                if (temp(j,i+1) .eq. 0) arr2(j,i+1) = 0
                                if (temp(j-1,i) .le. 0) arr2(j,i) = 0
                            endif
                        endif       
                    else                
                        if (i .lt. nr) then
                            if (temp(j+1,i+1) .le. 0 .and. temp(j-1,i+1)
     >                        .le. 0) then
                                if (temp(j,i+1) .eq. 0) arr2(j,i+1) = 0
                                if (temp(j+1,i) .le. 0 .and. temp(j-1,i)
     >                            .le. 0) arr2(j,i) = 0
                            endif
                        endif               
                    endif
                endif
            endif
            if (i .lt. nr) then
                if (arr(j,i+1) .eq. landval) then
                    if (j .eq. 1) then
                        if (i .gt. 1) then
                            if (temp(j+1,i-1) .le. 0) then
                                if (temp(j,i-1) .eq. 0) arr2(j,i-1) = 0
                                if (temp(j+1,i) .le. 0) arr2(j,i) = 0
                            endif
                        endif
                    else if (j .eq. nc) then            
                        if (i .gt. 1) then
                            if (temp(j-1,i-1) .le. 0) then
                                if (temp(j,i-1) .eq. 0) arr2(j,i-1) = 0
                                if (temp(j-1,i) .le. 0) arr2(j,i) = 0
                            endif
                        endif
                    else
                        if (i .gt. 1) then
                            if (temp(j+1,i-1) .le. 0 .and. temp(j-1,i-1)
     >                        .le. 0) then
                                if (temp(j,i-1) .eq. 0) arr2(j,i-1) = 0 
                                if (temp(j+1,i) .le. 0 .and. temp(j-1,i)
     >                            .le. 0) arr2(j,i) = 0
                            endif
                        endif       
                    endif
                endif
            endif
            if (j .gt. 1) then  
                if (arr(j-1,i) .eq. landval) then
                    if (i .eq. 1) then          
                        if (j .lt. nc) then
                            if (temp(j+1,i+1) .le. 0) then
                                if (temp(j+1,i) .eq. 0) arr2(j+1,i) = 0
                                if (temp(j,i+1) .le. 0) arr2(j,i) = 0
                            endif
                        endif
                    else if (i .eq. nr) then
                        if (j .lt. nc) then
                            if (temp(j+1,i-1) .le. 0) then
                                if (temp(j+1,i) .eq. 0) arr2(j+1,i) = 0
                                if (temp(j,i-1) .le. 0) arr2(j,i) = 0
                            endif
                        endif
                    else
                        if (j .lt. nc) then
                            if (temp(j+1,i+1) .le. 0 .and. temp(j+1,i+1)
     >                        .le. 0) then
                                if (temp(j+1,i) .eq. 0) arr2(j+1,i) = 0
                                if (temp(j,i-1) .le. 0 .and. temp(j,i+1)
     >                            .le. 0) arr2(j,i) = 0
                            endif
                        endif       
                    endif
                endif
            endif
            if (j .lt. nc) then
                if (arr(j+1,i) .eq. landval) then
                    if (i .eq. 1) then  
                        if (j .gt. 1) then
                            if (temp(j-1,i+1) .le. 0) then
                                if (temp(j-1,i) .eq. 0) arr2(j-1,i) = 0
                                if (temp(j,i+1) .le. 0) arr2(j,i) = 0
                            endif
                        endif
                    else if (i .eq. nr) then
                        if (j .gt. 1) then
                            if (temp(j-1,i-1) .le. 0) then
                                if (temp(j-1,i) .eq. 0) arr2(j-1,i) = 0
                                if (temp(j,i-1) .le. 0) arr2(j,i) = 0
                            endif
                        endif       
                    else
                        if (j .gt. 1) then
                            if (temp(j-1,i-1) .le. 0 .and. temp(j-1,i+1)
     >                        .le. 0) then
                                if (temp(j-1,i) .eq. 0) arr2(j-1,i) = 0 
                                if (temp(j,i-1) .le. 0 .and. temp(j,i+1)
     >                            .le. 0) arr2(j,i) = 0         
                            endif
                        endif       
                    endif
                endif
            endif
        endif
        enddo
        enddo

        do i=1,nr
        do j=1,nc
          arr(j,i)=arr2(j,i)
        enddo
        enddo

        RETURN
        END
