/* thsmooth.h  --  header file for tophat spectrum noise reduction program */

/* thsmooth version 1.0   7 June 1994              */
/* morphological image noise reduction program     */
/*                                                 */ 
/* by Richard Alan Peters II                       */
/* Department of Electrical Engineering            */
/* Vanderbilt University School of Engineering     */ 
/* Nashville, TN 37235                             */ 
/* rap2@vuse.vanderbilt.edu                        */ 
/*                                                 */ 
/* This software is freely redistributable if      */ 
/* the author's name and affiliation are included. */

/* includes */

#include <ctype.h>
#include <math.h>
#include <malloc.h>			
#include <stdio.h>	
#include <string.h>


/* defs */

#define SEPATH	"SEPATH"	/* structuring element directory env. var */

#define DISK    1		/* quazi disk-shaped SE family */
#define HORZ    2		/* horizontal line SE family */
#define VERT    3		/* vertical line SE family */
#define SEFL    4		/* SE family is in files */

#define BLACK	0
#define WHITE	255
#define TRUE	1
#define FALSE	0
#define ZERO	0
#define NSIZE	256
#define ALLOC	TRUE

#define MIN(a,b) ((a<b)?(a):(b))
#define MAX(a,b) ((a>b)?(a):(b))
#define FNLGTH    64   /* maximum file name string length */
#define DFLTTMF  1.0   /* default threshold multiplication factor */
#define NBANDS    32   /* maximum number of tophat bands allowed */


/* typedefs */

#ifndef BYTE
typedef unsigned char byte;
#define BYTE 1
#endif

#ifndef WORD
typedef short int word;
#define WORD
#endif

static void AddImg();
static void AndImg();
static void CheckSEfiles();
static void DilateMask();
static void GetCLArgs();
static int  Moment2();
static void ReadIt();
static char *rindex();
static void Thresh();
static void ThreshRef();
static void WriteIt();
