/* moment2.c  --  subroutine to calculate the second moment of a byte array */

/* dependencies: none   */

/* moment2 version 1.0   7 June 1994                 */
/* returns statistical second moment of a byte array */
/*                                                   */
/* by Richard Alan Peters II                         */
/* Department of Electrical Engineering              */
/* Vanderbilt University School of Engineering       */
/* Nashville, TN 37235                               */
/* rap2@vuse.vanderbilt.edu                          */
/*                                                   */
/* This software is freely redistributable if        */
/* the author's name and affiliation are included.   */

#include <math.h>
#include <stdio.h>
#include "moment2.h"


int moment2( Img, X, Y )
   byte *Img;
   int   X,Y;
   {
   byte *I;
   int i,j,n;
   int histo[WHITE+1];
   int *h;
   int area;
   int rank;
   int T;
   double a,m,p;

   /* zero the histogram */
   memset(histo,'\000',sizeof(int)*(WHITE+1));

   /* collect histogram */
   n = X*Y;
   I = Img;
   for (i=0; i<n; ++i)  
      (*(histo + *(I++)))++;    


   /* calculate area of histogram */
   area = 0;
   h = histo;
   for (i=0; i<=WHITE; ++i)  
      area += *(h++);

   /* calculate second moment of histogram */
   a = (double)area;
   h = histo;
   m = 0;
   for (i=0; i<=WHITE; ++i)
      {
      p  = (double)(*(h++)) / a;
      m += p * (double)(i*i);
      }
   m = sqrt(m);
   T = (int)(m + 0.5);

   return(T);

   }


