################################################################################
#@***h* Sea_Ice_CDR/test_noaa_util.py
#
# NAME
#  test_noaa_util.py
#
# LOCATION
#  tests/test_noaa_util.py
#
# PURPOSE
#  Unit tests for the noaa_util module.
#
# DESCRIPTION
#  Unit tests for the noaa_util module.
#
# AUTHOR
#  nsidc@nsidc.org
#  National Snow & Ice Data Center, University of Colorado, Boulder
#
# COPYRIGHT
#  Copyright 2011 Regents of the University of Colorado. The Regents of the
#  University of Colorado grants, and you accept, a personal, nonexclusive,
#  nontransferable license to use this software, at no charge, in accordance
#  with the terms herein, solely for internal research and development, which
#  is limited to testing, measuring, assessing, evaluating the software and/or
#  data that you generate using this software, and not for any commercial
#  purpose. You may not develop derivative works based on this software, or
#  redistribute this software.
#
# CREATION DATE
#  April 2013
#
# EXTERNALS
#  unittest2
#  noaa_util
#
# SUBROUTINES
#   class NOAAUtilTests
#     test_class_methods
#     test_class_name
#     test_function_names
#
# INPUTS
#  n/a
#
# OUTPUTS
#  n/a
#
# MODIFICATION HISTORY
#
#
#@*****
################################################################################
import unittest2
import noaa_util


class NOAAUtilTests(unittest2.TestCase):
    def test_function_names(self):
        expected = ['bar', 'foo']
        actual = noaa_util.function_names('stub_module')
        self.assertEqual(expected, actual)

    def test_class_name(self):
        expected = 'FizzBizz'
        class_info = noaa_util.classes('stub_module')[0]
        actual = class_info[0]
        self.assertEqual(expected, actual)

    def test_class_methods(self):
        expected = ['bizz', 'fizz']
        class_info = noaa_util.classes('stub_module')[0]
        actual = class_info[1]
        self.assertEqual(expected, actual)


if __name__ == "__main__":
    unittest2.main()
